# Class: YARD::Handlers::Ruby::Legacy::ConstantHandler

Inherits:
  Base
  - Object
  - Base
  - Base
  - YARD::Handlers::Ruby::Legacy::ConstantHandler
  show all

Includes:
  StructHandlerMethods

Defined in:
  lib/yard/handlers/ruby/legacy/constant_handler.rb

## Overview

Handles any constant assignment

## Constant Summary collapse

HANDLER_MATCH =

      /\A[A-Z]\w*\s*=[^=]\s*/m

### Constants included from CodeObjects

CodeObjects::BUILTIN_ALL, CodeObjects::BUILTIN_CLASSES, CodeObjects::BUILTIN_EXCEPTIONS, CodeObjects::BUILTIN_EXCEPTIONS_HASH, CodeObjects::BUILTIN_MODULES, CodeObjects::CONSTANTMATCH, CodeObjects::CONSTANTSTART, CodeObjects::CSEP, CodeObjects::CSEPQ, CodeObjects::ISEP, CodeObjects::ISEPQ, CodeObjects::METHODMATCH, CodeObjects::METHODNAMEMATCH, CodeObjects::NAMESPACEMATCH, CodeObjects::NSEP, CodeObjects::NSEPQ

### Constants included from Parser::Ruby::Legacy::RubyToken

Parser::Ruby::Legacy::RubyToken::EXPR_ARG, Parser::Ruby::Legacy::RubyToken::EXPR_BEG, Parser::Ruby::Legacy::RubyToken::EXPR_CLASS, Parser::Ruby::Legacy::RubyToken::EXPR_DOT, Parser::Ruby::Legacy::RubyToken::EXPR_END, Parser::Ruby::Legacy::RubyToken::EXPR_FNAME, Parser::Ruby::Legacy::RubyToken::EXPR_MID, Parser::Ruby::Legacy::RubyToken::NEWLINE_TOKEN, Parser::Ruby::Legacy::RubyToken::TkReading2Token, Parser::Ruby::Legacy::RubyToken::TkSymbol2Token

## Instance Method Summary collapse

- #process ⇒ void

  Main processing callback.

### Methods included from StructHandlerMethods

#add_reader_tags, #add_writer_tags, #create_attributes, #create_class, #create_member_method?, #create_reader, #create_writer, #member_tag_for_member, #members_from_tags, #parameter_tag_for_member, #register_docstring, #register_struct_member_method, #return_type_from_tag, #type_tag_for_member

### Methods included from CodeObjects::NamespaceMapper

#clear_separators, #default_separator, on_invalidate, #register_separator, #separators, #separators_for_type, #separators_match, #types_for_separator, #unregister_separator_by_type

## Constructor Details

This class inherits a constructor from YARD::Handlers::Base

## Instance Method Details

### #process ⇒ `void`

This method returns an undefined value.

Main processing callback

    9
    10
    11
    12
    13
    14
    15
    16

    # File 'lib/yard/handlers/ruby/legacy/constant_handler.rb', line 9

    process do
      name, value = *statement.tokens.to_s.split(/\s*=\s*/, 2)
      if value =~ /\A\s*Struct.new(?:\s*\(?|\b)/
        process_structclass(name, $')
      else
        register ConstantObject.new(namespace, name) {|o| o.source = statement; o.value = value.strip }
      end
    end